//**********************************************//
//******************KAmodBMP085******************//
//**********************************************//

//W folderze do ktrego rozpakujemy archiwum example.zip musi 
//znajdowac sie folder z biblioteka "STM32F10x_StdPeriph_Lib_V3.5.0"
//w celu poprawnej kompilacji programu.


//****************LCD - ZL27ARM*****************//
//LCD_D0 - JP10(PE0)
//LCD_D1 - JP10(PE1)
//LCD_D2 - JP10(PE2)
//LCD_D3 - JP10(PE3)
//LCD_D4 - JP10(PE4)
//LCD_D5 - JP10(PE5)
//LCD_D6 - JP10(PE6)
//LCD_D7 - JP10(PE7)
//LCD_RS - JP10(PE8)
//LCD_RW - JP10(PE9)
//LCD_EN - JP10(PE10)
//LCD_+V - JP10(+3.3V)
//LCD_GND - JP10(GND)

//**************KAmodBMP085 - ZL27ARM*************//
//Con1_SCL - JP5(PB6)
//Con1_SDA - JP5(PB7)
//Con1_+V - JP5(+3.3V)
//Con1_GND - JP5(GND)


#include "stm32f10x.h"
#include "Inicjalizacja.h"
#include ".\..\Moduly\Czujniki\Cisnienie\BMP085.h"
#include "lcd_hd44780_lib.h"
#include "Sprzet.h"
#include "stdio.h"
#include "stdlib.h"

//Zmienne dla danych z czujnika
short ac1;
short ac2;
short ac3;
unsigned short ac4;
unsigned short ac5;
unsigned short ac6;
short b1;
short b2;
short mb;
short mc;
short md;



int main(void)
{
	short temperature = 0;
  long pressure = 0;
	long altitude =0.0;
	unsigned char Teksttemp[5] = {"\0"};
	unsigned char Tekstpres[8] = {"\0"};	
	unsigned char Tekstalt[11] = {"\0"};
	
	//Konfiguracja systemu
	RCC_Configuration();
  NVIC_Configuration();
	GPIO_Configuration();
	BMP085_Configuration();
	
	//Wylaczenie LED
	GPIO_ResetBits(LED_PORT, LED1 | LED2 | LED3 | LED4 | LED5 | LED6 | LED7 | LED8);		
	
	//Inicjalizacja LCD
  LCD_Initialize();                              
  LCD_WriteCommand(HD44780_CLEAR);               
  LCD_WriteTextXY("Kalibracja...\0",0,0);  	
	
	//Kalibracja BMP085
	BMP085_Calibration();
	//Jesli kalibracja ok to wlacz LED1
	GPIO_WriteBit(GPIOB, GPIO_Pin_8, SET);
	//
	LCD_WriteTextXY("T=    C P=       Pa\0",0,0);
	LCD_WriteTextXY("   Wys=          \0",0,1);
	
	while(1)
	{
	//Oblicz temp, cisnienie, wysokosc
	BMP085_Convert(&temperature,&pressure,&altitude);	
		
	//PrzeksztaBcanie liczb na stringa
	//Liczba dziesietna 5 cyfrowa z 2 cywrowa liczba po przecinku
	sprintf((char *)Tekstalt,"%5d.%02dm \0",altitude/100,altitude-((altitude/100)*100));
	//liczba dziesietna 4 cyfrowa	
	sprintf((char *)Teksttemp,"%4d\0",temperature);
	//liczba dziesietna 7 cyfrowa
	sprintf((char *)Tekstpres,"%7d\0",pressure);	 
		
	//Wyswietlenie danych
	LCD_WriteTextXY(Tekstalt,7,1);
	LCD_WriteTextXY(Teksttemp,2,0);
	LCD_WriteTextXY(Tekstpres,10,0);
	//Zmiana stanu LED8 na ZL27ARM
	GPIO_WriteBit(GPIOB, GPIO_Pin_15, (BitAction)(1-GPIO_ReadOutputDataBit(GPIOB, GPIO_Pin_15)));		
	}
	
}
